package solutions.bitbadger.documents

/**
 * The type of index to generate for the document
 */
enum class DocumentIndex(val sql: String) {

    /** A GIN index with standard operations (all operators supported) */
    FULL(""),

    /** A GIN index with JSONPath operations (optimized for @>, @?, @@ operators) */
    OPTIMIZED(" jsonb_path_ops")
}
