package solutions.bitbadger.documents.core.tests.java.integration;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.core.tests.integration.PgDB;

/**
 * PostgreSQL integration tests for the `Definition` object / `ensure*` connection extension functions
 */
@DisplayName("Core | Java | PostgreSQL: Definition")
final public class PostgreSQLDefinitionIT {

    @Test
    @DisplayName("ensureTable creates table and index")
    public void ensureTable() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DefinitionFunctions.ensuresATable(db);
        }
    }

    @Test
    @DisplayName("ensureFieldIndex creates an index")
    public void ensureFieldIndex() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DefinitionFunctions.ensuresAFieldIndex(db);
        }
    }

    @Test
    @DisplayName("ensureDocumentIndex creates a full index")
    public void ensureDocumentIndexFull() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DefinitionFunctions.ensureDocumentIndexFull(db);
        }
    }

    @Test
    @DisplayName("ensureDocumentIndex creates an optimized index")
    public void ensureDocumentIndexOptimized() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DefinitionFunctions.ensureDocumentIndexOptimized(db);
        }
    }
}
