package solutions.bitbadger.documents.core.tests.java.integration;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.core.tests.integration.PgDB;

/**
 * PostgreSQL integration tests for the `Delete` object / `deleteBy*` connection extension functions
 */
@DisplayName("Core | Java | PostgreSQL: Delete")
final public class PostgreSQLDeleteIT {
    
    @Test
    @DisplayName("byId deletes a matching ID")
    public void byIdMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byIdMatch(db);
        }
    }

    @Test
    @DisplayName("byId succeeds when no ID matches")
    public void byIdNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byIdNoMatch(db);
        }
    }

    @Test
    @DisplayName("byFields deletes matching documents")
    public void byFieldsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byFieldsMatch(db);
        }
    }

    @Test
    @DisplayName("byFields succeeds when no documents match")
    public void byFieldsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byFieldsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byContains deletes matching documents")
    public void byContainsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byContainsMatch(db);
        }
    }

    @Test
    @DisplayName("byContains succeeds when no documents match")
    public void byContainsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byContainsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath deletes matching documents")
    public void byJsonPathMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byJsonPathMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath succeeds when no documents match")
    public void byJsonPathNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            DeleteFunctions.byJsonPathNoMatch(db);
        }
    }
}
