package solutions.bitbadger.documents.core.tests.java.integration;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.core.tests.integration.PgDB;

/**
 * PostgreSQL integration tests for the `Patch` object / `patchBy*` connection extension functions
 */
@DisplayName("Core | Java | PostgreSQL: Patch")
final public class PostgreSQLPatchIT {

    @Test
    @DisplayName("byId patches an existing document")
    public void byIdMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byIdMatch(db);
        }
    }

    @Test
    @DisplayName("byId succeeds for a non-existent document")
    public void byIdNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byIdNoMatch(db);
        }
    }

    @Test
    @DisplayName("byFields patches matching document")
    public void byFieldsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byFieldsMatch(db);
        }
    }

    @Test
    @DisplayName("byFields succeeds when no documents match")
    public void byFieldsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byFieldsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byContains patches matching document")
    public void byContainsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byContainsMatch(db);
        }
    }

    @Test
    @DisplayName("byContains succeeds when no documents match")
    public void byContainsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byContainsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath patches matching document")
    public void byJsonPathMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byJsonPathMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath succeeds when no documents match")
    public void byJsonPathNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            PatchFunctions.byJsonPathNoMatch(db);
        }
    }
}
