package solutions.bitbadger.documents.core.tests.java.integration;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.core.tests.integration.SQLiteDB;

import static org.junit.jupiter.api.Assertions.assertThrows;

/**
 * SQLite integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("Core | Java | SQLite: Count")
public class SQLiteCountIT {

    @Test
    @DisplayName("all counts all documents")
    public void all() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CountFunctions.all(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    public void byFieldsNumeric() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CountFunctions.byFieldsNumeric(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    public void byFieldsAlpha() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CountFunctions.byFieldsAlpha(db);
        }
    }

    @Test
    @DisplayName("byContains fails")
    public void byContainsMatch() {
        try (SQLiteDB db = new SQLiteDB()) {
            assertThrows(DocumentException.class, () -> CountFunctions.byContainsMatch(db));
        }
    }

    @Test
    @DisplayName("byJsonPath fails")
    public void byJsonPathMatch() {
        try (SQLiteDB db = new SQLiteDB()) {
            assertThrows(DocumentException.class, () -> CountFunctions.byJsonPathMatch(db));
        }
    }
}
