package solutions.bitbadger.documents.core.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * PostgreSQL integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("Core | Kotlin | PostgreSQL: Count")
class PostgreSQLCountIT {

    @Test
    @DisplayName("all counts all documents")
    fun all() =
        PgDB().use(CountFunctions::all)

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    fun byFieldsNumeric() =
        PgDB().use(CountFunctions::byFieldsNumeric)

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    fun byFieldsAlpha() =
        PgDB().use(CountFunctions::byFieldsAlpha)

    @Test
    @DisplayName("byContains counts documents when matches are found")
    fun byContainsMatch() =
        PgDB().use(CountFunctions::byContainsMatch)

    @Test
    @DisplayName("byContains counts documents when no matches are found")
    fun byContainsNoMatch() =
        PgDB().use(CountFunctions::byContainsNoMatch)

    @Test
    @DisplayName("byJsonPath counts documents when matches are found")
    fun byJsonPathMatch() =
        PgDB().use(CountFunctions::byJsonPathMatch)

    @Test
    @DisplayName("byJsonPath counts documents when no matches are found")
    fun byJsonPathNoMatch() =
        PgDB().use(CountFunctions::byJsonPathNoMatch)
}
