package solutions.bitbadger.documents.groovy.tests

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.Op

import static org.junit.jupiter.api.Assertions.assertEquals

/**
 * Unit tests for the `Op` enum
 */
@DisplayName('Groovy | Op')
class OpTest {

    @Test
    @DisplayName('EQUAL uses proper SQL')
    void equalSQL() {
        assertEquals '=', Op.EQUAL.sql, 'The SQL for equal is incorrect'
    }

    @Test
    @DisplayName('GREATER uses proper SQL')
    void greaterSQL() {
        assertEquals '>', Op.GREATER.sql, 'The SQL for greater is incorrect'
    }

    @Test
    @DisplayName('GREATER_OR_EQUAL uses proper SQL')
    void greaterOrEqualSQL() {
        assertEquals '>=', Op.GREATER_OR_EQUAL.sql, 'The SQL for greater-or-equal is incorrect'
    }

    @Test
    @DisplayName('LESS uses proper SQL')
    void lessSQL() {
        assertEquals '<', Op.LESS.sql, 'The SQL for less is incorrect'
    }

    @Test
    @DisplayName('LESS_OR_EQUAL uses proper SQL')
    void lessOrEqualSQL() {
        assertEquals '<=', Op.LESS_OR_EQUAL.sql, 'The SQL for less-or-equal is incorrect'
    }

    @Test
    @DisplayName('NOT_EQUAL uses proper SQL')
    void notEqualSQL() {
        assertEquals '<>', Op.NOT_EQUAL.sql, 'The SQL for not-equal is incorrect'
    }

    @Test
    @DisplayName('BETWEEN uses proper SQL')
    void betweenSQL() {
        assertEquals 'BETWEEN', Op.BETWEEN.sql, 'The SQL for between is incorrect'
    }

    @Test
    @DisplayName('IN uses proper SQL')
    void inSQL() {
        assertEquals 'IN', Op.IN.sql, 'The SQL for in is incorrect'
    }

    @Test
    @DisplayName('IN_ARRAY uses proper SQL')
    void inArraySQL() {
        assertEquals '??|', Op.IN_ARRAY.sql, 'The SQL for in-array is incorrect'
    }

    @Test
    @DisplayName('EXISTS uses proper SQL')
    void existsSQL() {
        assertEquals 'IS NOT NULL', Op.EXISTS.sql, 'The SQL for exists is incorrect'
    }

    @Test
    @DisplayName('NOT_EXISTS uses proper SQL')
    void notExistsSQL() {
        assertEquals 'IS NULL', Op.NOT_EXISTS.sql, 'The SQL for not-exists is incorrect'
    }
}
