package solutions.bitbadger.documents.groovy.tests.integration

import static solutions.bitbadger.documents.groovy.tests.Types.TEST_TABLE

class JsonDocument {
    String id
    String value
    int numValue
    SubDocument sub

    JsonDocument(String id = null, String value = "", int numValue = 0, SubDocument sub = null) {
        this.id = id
        this.value = value
        this.numValue = numValue
        this.sub = sub
    }

    private static final List<JsonDocument> testDocuments = List.of(
            new JsonDocument("one", "FIRST!", 0),
            new JsonDocument("two", "another", 10, new SubDocument("green", "blue")),
            new JsonDocument("three", "", 4),
            new JsonDocument("four", "purple", 17, new SubDocument("green", "red")),
            new JsonDocument("five", "purple", 18))

    static void load(ThrowawayDatabase db, String tableName = TEST_TABLE) {
        testDocuments.forEach { db.conn.insert(tableName, it) }
    }

    /** Document ID <code>one</code> as a JSON string */
    static String one = '{"id":"one","value":"FIRST!","numValue":0,"sub":null}'

    /** Document ID <code>two</code> as a JSON string */
    static String two = '{"id":"two","value":"another","numValue":10,"sub":{"foo":"green","bar":"blue"}}'

    /** Document ID <code>three</code> as a JSON string */
    static String three = '{"id":"three","value":"","numValue":4,"sub":null}'

    /** Document ID <code>four</code> as a JSON string */
    static String four = '{"id":"four","value":"purple","numValue":17,"sub":{"foo":"green","bar":"red"}}'

    /** Document ID <code>five</code> as a JSON string */
    static String five = '{"id":"five","value":"purple","numValue":18,"sub":null}'
}
