package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Custom')
final class PostgreSQLCustomIT {

    @Test
    @DisplayName('list succeeds with empty list')
    void listEmpty() {
        new PgDB().withCloseable CustomFunctions.&listEmpty
    }

    @Test
    @DisplayName('list succeeds with a non-empty list')
    void listAll() {
        new PgDB().withCloseable CustomFunctions.&listAll
    }

    @Test
    @DisplayName('jsonArray succeeds with empty array')
    void jsonArrayEmpty() {
        new PgDB().withCloseable CustomFunctions.&jsonArrayEmpty
    }

    @Test
    @DisplayName('jsonArray succeeds with a single-item array')
    void jsonArraySingle() {
        new PgDB().withCloseable CustomFunctions.&jsonArraySingle
    }

    @Test
    @DisplayName('jsonArray succeeds with a multi-item array')
    void jsonArrayMany() {
        new PgDB().withCloseable CustomFunctions.&jsonArrayMany
    }

    @Test
    @DisplayName('writeJsonArray succeeds with empty array')
    void writeJsonArrayEmpty() {
        new PgDB().withCloseable CustomFunctions.&writeJsonArrayEmpty
    }

    @Test
    @DisplayName('writeJsonArray succeeds with a single-item array')
    void writeJsonArraySingle() {
        new PgDB().withCloseable CustomFunctions.&writeJsonArraySingle
    }

    @Test
    @DisplayName('writeJsonArray succeeds with a multi-item array')
    void writeJsonArrayMany() {
        new PgDB().withCloseable CustomFunctions.&writeJsonArrayMany
    }

    @Test
    @DisplayName('single succeeds when document not found')
    void singleNone() {
        new PgDB().withCloseable CustomFunctions.&singleNone
    }

    @Test
    @DisplayName('single succeeds when a document is found')
    void singleOne() {
        new PgDB().withCloseable CustomFunctions.&singleOne
    }

    @Test
    @DisplayName('jsonSingle succeeds when document not found')
    void jsonSingleNone() {
        new PgDB().withCloseable CustomFunctions.&jsonSingleNone
    }

    @Test
    @DisplayName('jsonSingle succeeds when a document is found')
    void jsonSingleOne() {
        new PgDB().withCloseable CustomFunctions.&jsonSingleOne
    }

    @Test
    @DisplayName('nonQuery makes changes')
    void nonQueryChanges() {
        new PgDB().withCloseable CustomFunctions.&nonQueryChanges
    }

    @Test
    @DisplayName('nonQuery makes no changes when where clause matches nothing')
    void nonQueryNoChanges() {
        new PgDB().withCloseable CustomFunctions.&nonQueryNoChanges
    }

    @Test
    @DisplayName('scalar succeeds')
    void scalar() {
        new PgDB().withCloseable CustomFunctions.&scalar
    }
}
