package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Definition` object / `ensure*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Definition')
final class PostgreSQLDefinitionIT {

    @Test
    @DisplayName('ensureTable creates table and index')
    void ensureTable() {
        new PgDB().withCloseable DefinitionFunctions.&ensureTable
    }

    @Test
    @DisplayName('ensureFieldIndex creates an index')
    void ensureFieldIndex() {
        new PgDB().withCloseable DefinitionFunctions.&ensureFieldIndex
    }

    @Test
    @DisplayName('ensureDocumentIndex creates a full index')
    void ensureDocumentIndexFull() {
        new PgDB().withCloseable DefinitionFunctions.&ensureDocumentIndexFull
    }

    @Test
    @DisplayName('ensureDocumentIndex creates an optimized index')
    void ensureDocumentIndexOptimized() {
        new PgDB().withCloseable DefinitionFunctions.&ensureDocumentIndexOptimized
    }
}
