package solutions.bitbadger.documents.groovy.tests.integration

import solutions.bitbadger.documents.AutoId
import java.sql.Connection

/**
 * Common trait for PostgreSQL and SQLite throwaway databases
 */
trait ThrowawayDatabase implements AutoCloseable {

    /** The database connection for the throwaway database */
    Connection conn

    /**
     * Determine if a database object exists
     *
     * @param name The name of the object whose existence should be checked
     * @return True if the object exists, false if not
     */
    abstract boolean dbObjectExists(String name)

    /** The name for the throwaway database */
    String dbName = "throwaway_${AutoId.generateRandomString(8)}"
}
