package solutions.bitbadger.documents.kotlinx.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * PostgreSQL integration tests for the `Delete` object / `deleteBy*` connection extension functions
 */
@DisplayName("KotlinX | PostgreSQL: Delete")
class PostgreSQLDeleteIT {

    @Test
    @DisplayName("byId deletes a matching ID")
    fun byIdMatch() =
        PgDB().use(DeleteFunctions::byIdMatch)

    @Test
    @DisplayName("byId succeeds when no ID matches")
    fun byIdNoMatch() =
        PgDB().use(DeleteFunctions::byIdNoMatch)

    @Test
    @DisplayName("byFields deletes matching documents")
    fun byFieldsMatch() =
        PgDB().use(DeleteFunctions::byFieldsMatch)

    @Test
    @DisplayName("byFields succeeds when no documents match")
    fun byFieldsNoMatch() =
        PgDB().use(DeleteFunctions::byFieldsNoMatch)

    @Test
    @DisplayName("byContains deletes matching documents")
    fun byContainsMatch() =
        PgDB().use(DeleteFunctions::byContainsMatch)

    @Test
    @DisplayName("byContains succeeds when no documents match")
    fun byContainsNoMatch() =
        PgDB().use(DeleteFunctions::byContainsNoMatch)

    @Test
    @DisplayName("byJsonPath deletes matching documents")
    fun byJsonPathMatch() =
        PgDB().use(DeleteFunctions::byJsonPathMatch)

    @Test
    @DisplayName("byJsonPath succeeds when no documents match")
    fun byJsonPathNoMatch() =
        PgDB().use(DeleteFunctions::byJsonPathNoMatch)
}
