package solutions.bitbadger.documents.kotlinx.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * PostgreSQL integration tests for the `Exists` object / `existsBy*` connection extension functions
 */
@DisplayName("KotlinX | PostgreSQL: Exists")
class PostgreSQLExistsIT {

    @Test
    @DisplayName("byId returns true when a document matches the ID")
    fun byIdMatch() =
        PgDB().use(ExistsFunctions::byIdMatch)

    @Test
    @DisplayName("byId returns false when no document matches the ID")
    fun byIdNoMatch() =
        PgDB().use(ExistsFunctions::byIdNoMatch)

    @Test
    @DisplayName("byFields returns true when documents match")
    fun byFieldsMatch() =
        PgDB().use(ExistsFunctions::byFieldsMatch)

    @Test
    @DisplayName("byFields returns false when no documents match")
    fun byFieldsNoMatch() =
        PgDB().use(ExistsFunctions::byFieldsNoMatch)

    @Test
    @DisplayName("byContains returns true when documents match")
    fun byContainsMatch() =
        PgDB().use(ExistsFunctions::byContainsMatch)

    @Test
    @DisplayName("byContains returns false when no documents match")
    fun byContainsNoMatch() =
        PgDB().use(ExistsFunctions::byContainsNoMatch)

    @Test
    @DisplayName("byJsonPath returns true when documents match")
    fun byJsonPathMatch() =
        PgDB().use(ExistsFunctions::byJsonPathMatch)

    @Test
    @DisplayName("byJsonPath returns false when no documents match")
    fun byJsonPathNoMatch() =
        PgDB().use(ExistsFunctions::byJsonPathNoMatch)
}
