package solutions.bitbadger.documents.kotlinx.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * SQLite integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName("KotlinX | SQLite: Custom")
class SQLiteCustomIT {

    @Test
    @DisplayName("list succeeds with empty list")
    fun listEmpty() =
        SQLiteDB().use(CustomFunctions::listEmpty)

    @Test
    @DisplayName("list succeeds with a non-empty list")
    fun listAll() =
        SQLiteDB().use(CustomFunctions::listAll)

    @Test
    @DisplayName("jsonArray succeeds with empty array")
    fun jsonArrayEmpty() =
        SQLiteDB().use(CustomFunctions::jsonArrayEmpty)

    @Test
    @DisplayName("jsonArray succeeds with a single-item array")
    fun jsonArraySingle() =
        SQLiteDB().use(CustomFunctions::jsonArraySingle)

    @Test
    @DisplayName("jsonArray succeeds with a multi-item array")
    fun jsonArrayMany() =
        SQLiteDB().use(CustomFunctions::jsonArrayMany)

    @Test
    @DisplayName("writeJsonArray succeeds with empty array")
    fun writeJsonArrayEmpty() =
        SQLiteDB().use(CustomFunctions::writeJsonArrayEmpty)

    @Test
    @DisplayName("writeJsonArray succeeds with a single-item array")
    fun writeJsonArraySingle() =
        SQLiteDB().use(CustomFunctions::writeJsonArraySingle)

    @Test
    @DisplayName("writeJsonArray succeeds with a multi-item array")
    fun writeJsonArrayMany() =
        SQLiteDB().use(CustomFunctions::writeJsonArrayMany)

    @Test
    @DisplayName("single succeeds when document not found")
    fun singleNone() =
        SQLiteDB().use(CustomFunctions::singleNone)

    @Test
    @DisplayName("single succeeds when a document is found")
    fun singleOne() =
        SQLiteDB().use(CustomFunctions::singleOne)

    @Test
    @DisplayName("jsonSingle succeeds when document not found")
    fun jsonSingleNone() =
        SQLiteDB().use(CustomFunctions::jsonSingleNone)

    @Test
    @DisplayName("jsonSingle succeeds when a document is found")
    fun jsonSingleOne() =
        SQLiteDB().use(CustomFunctions::jsonSingleOne)

    @Test
    @DisplayName("nonQuery makes changes")
    fun nonQueryChanges() =
        SQLiteDB().use(CustomFunctions::nonQueryChanges)

    @Test
    @DisplayName("nonQuery makes no changes when where clause matches nothing")
    fun nonQueryNoChanges() =
        SQLiteDB().use(CustomFunctions::nonQueryNoChanges)

    @Test
    @DisplayName("scalar succeeds")
    fun scalar() =
        SQLiteDB().use(CustomFunctions::scalar)
}
