package solutions.bitbadger.documents.scala.tests

import org.junit.jupiter.api.Assertions.*
import org.junit.jupiter.api.{DisplayName, Test}
import solutions.bitbadger.documents.Op

@DisplayName("Scala | Op")
class OpTest:

  @Test
  @DisplayName("EQUAL uses proper SQL")
  def equalSQL(): Unit =
    assertEquals("=", Op.EQUAL.getSql, "The SQL for equal is incorrect")

  @Test
  @DisplayName("GREATER uses proper SQL")
  def greaterSQL(): Unit =
    assertEquals(">", Op.GREATER.getSql, "The SQL for greater is incorrect")

  @Test
  @DisplayName("GREATER_OR_EQUAL uses proper SQL")
  def greaterOrEqualSQL(): Unit =
    assertEquals(">=", Op.GREATER_OR_EQUAL.getSql, "The SQL for greater-or-equal is incorrect")

  @Test
  @DisplayName("LESS uses proper SQL")
  def lessSQL(): Unit =
    assertEquals("<", Op.LESS.getSql, "The SQL for less is incorrect")

  @Test
  @DisplayName("LESS_OR_EQUAL uses proper SQL")
  def lessOrEqualSQL(): Unit =
    assertEquals("<=", Op.LESS_OR_EQUAL.getSql, "The SQL for less-or-equal is incorrect")

  @Test
  @DisplayName("NOT_EQUAL uses proper SQL")
  def notEqualSQL(): Unit =
    assertEquals("<>", Op.NOT_EQUAL.getSql, "The SQL for not-equal is incorrect")

  @Test
  @DisplayName("BETWEEN uses proper SQL")
  def betweenSQL(): Unit =
    assertEquals("BETWEEN", Op.BETWEEN.getSql, "The SQL for between is incorrect")

  @Test
  @DisplayName("IN uses proper SQL")
  def inSQL(): Unit =
    assertEquals("IN", Op.IN.getSql, "The SQL for in is incorrect")

  @Test
  @DisplayName("IN_ARRAY uses proper SQL")
  def inArraySQL(): Unit =
    assertEquals("??|", Op.IN_ARRAY.getSql, "The SQL for in-array is incorrect")

  @Test
  @DisplayName("EXISTS uses proper SQL")
  def existsSQL(): Unit =
    assertEquals("IS NOT NULL", Op.EXISTS.getSql, "The SQL for exists is incorrect")

  @Test
  @DisplayName("NOT_EXISTS uses proper SQL")
  def notExistsSQL(): Unit =
    assertEquals("IS NULL", Op.NOT_EXISTS.getSql, "The SQL for not-exists is incorrect")
