package solutions.bitbadger.documents.scala.tests

import org.junit.jupiter.api.Assertions.*
import org.junit.jupiter.api.{DisplayName, Test}
import solutions.bitbadger.documents.ParameterName

@DisplayName("Scala | ParameterName")
class ParameterNameTest:

  @Test
  @DisplayName("derive works when given existing names")
  def withExisting(): Unit =
    val names = ParameterName()
    assertEquals(":taco", names.derive(":taco"), "Name should have been :taco")
    assertEquals(":field0", names.derive(null), "Counter should not have advanced for named field")

  @Test
  @DisplayName("derive works when given all anonymous fields")
  def allAnonymous(): Unit =
    val names = ParameterName()
    assertEquals(":field0", names.derive(null), "Anonymous field name should have been returned")
    assertEquals(":field1", names.derive(null), "Counter should have advanced from previous call")
    assertEquals(":field2", names.derive(null), "Counter should have advanced from previous call")
    assertEquals(":field3", names.derive(null), "Counter should have advanced from previous call")
