package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

@DisplayName("Scala | PostgreSQL: Count")
class PostgreSQLCountIT:

  @Test
  @DisplayName("all counts all documents")
  def all(): Unit =
    Using(PgDB()) { db => CountFunctions.all(db) }

  @Test
  @DisplayName("byFields counts documents by a numeric value")
  def byFieldsNumeric(): Unit =
    Using(PgDB()) { db => CountFunctions.byFieldsNumeric(db) }

  @Test
  @DisplayName("byFields counts documents by a alphanumeric value")
  def byFieldsAlpha(): Unit =
    Using(PgDB()) { db => CountFunctions.byFieldsAlpha(db) }

  @Test
  @DisplayName("byContains counts documents when matches are found")
  def byContainsMatch(): Unit =
    Using(PgDB()) { db => CountFunctions.byContainsMatch(db) }

  @Test
  @DisplayName("byContains counts documents when no matches are found")
  def byContainsNoMatch(): Unit =
    Using(PgDB()) { db => CountFunctions.byContainsNoMatch(db) }

  @Test
  @DisplayName("byJsonPath counts documents when matches are found")
  def byJsonPathMatch(): Unit =
    Using(PgDB()) { db => CountFunctions.byJsonPathMatch(db) }

  @Test
  @DisplayName("byJsonPath counts documents when no matches are found")
  def byJsonPathNoMatch(): Unit =
    Using(PgDB()) { db => CountFunctions.byJsonPathNoMatch(db) }
