package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

/**
 * PostgreSQL integration tests for the `Definition` object / `ensure*` connection extension functions
 */
@DisplayName("Scala | PostgreSQL: Definition")
class PostgreSQLDefinitionIT:

  @Test
  @DisplayName("ensureTable creates table and index")
  def ensureTable(): Unit =
    Using(PgDB()) { db => DefinitionFunctions.ensureTable(db) }

  @Test
  @DisplayName("ensureFieldIndex creates an index")
  def ensureFieldIndex(): Unit =
    Using(PgDB()) { db => DefinitionFunctions.ensureFieldIndex(db) }

  @Test
  @DisplayName("ensureDocumentIndex creates a full index")
  def ensureDocumentIndexFull(): Unit =
    Using(PgDB()) { db => DefinitionFunctions.ensureDocumentIndexFull(db) }

  @Test
  @DisplayName("ensureDocumentIndex creates an optimized index")
  def ensureDocumentIndexOptimized(): Unit =
    Using(PgDB()) { db => DefinitionFunctions.ensureDocumentIndexOptimized(db) }
