package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

/**
 * PostgreSQL integration tests for the `Patch` object / `patchBy*` connection extension functions
 */
@DisplayName("Scala | PostgreSQL: Patch")
class PostgreSQLPatchIT:
  
  @Test
  @DisplayName("byId patches an existing document")
  def byIdMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byIdMatch(db) }

  @Test
  @DisplayName("byId succeeds for a non-existent document")
  def byIdNoMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byIdNoMatch(db) }

  @Test
  @DisplayName("byFields patches matching document")
  def byFieldsMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byFieldsMatch(db) }

  @Test
  @DisplayName("byFields succeeds when no documents match")
  def byFieldsNoMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byFieldsNoMatch(db) }

  @Test
  @DisplayName("byContains patches matching document")
  def byContainsMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byContainsMatch(db) }

  @Test
  @DisplayName("byContains succeeds when no documents match")
  def byContainsNoMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byContainsNoMatch(db) }

  @Test
  @DisplayName("byJsonPath patches matching document")
  def byJsonPathMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byJsonPathMatch(db) }

  @Test
  @DisplayName("byJsonPath succeeds when no documents match")
  def byJsonPathNoMatch(): Unit =
    Using(PgDB()) { db => PatchFunctions. byJsonPathNoMatch(db) }
