package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

@DisplayName("Scala | SQLite: Custom")
class SQLiteCustomIT:

  @Test
  @DisplayName("list succeeds with empty list")
  def listEmpty(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.listEmpty(db) }

  @Test
  @DisplayName("list succeeds with a non-empty list")
  def listAll(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.listAll(db) }

  @Test
  @DisplayName("jsonArray succeeds with empty array")
  def jsonArrayEmpty(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.jsonArrayEmpty(db) }

  @Test
  @DisplayName("jsonArray succeeds with a single-item array")
  def jsonArraySingle(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.jsonArraySingle(db) }

  @Test
  @DisplayName("jsonArray succeeds with a multi-item array")
  def jsonArrayMany(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.jsonArrayMany(db) }

  @Test
  @DisplayName("writeJsonArray succeeds with empty array")
  def writeJsonArrayEmpty(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.writeJsonArrayEmpty(db) }

  @Test
  @DisplayName("writeJsonArray succeeds with a single-item array")
  def writeJsonArraySingle(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.writeJsonArraySingle(db) }

  @Test
  @DisplayName("writeJsonArray succeeds with a multi-item array")
  def writeJsonArrayMany(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.writeJsonArrayMany(db) }

  @Test
  @DisplayName("single succeeds when document not found")
  def singleNone(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.singleNone(db) }

  @Test
  @DisplayName("single succeeds when a document is found")
  def singleOne(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.singleOne(db) }

  @Test
  @DisplayName("jsonSingle succeeds when document not found")
  def jsonSingleNone(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.jsonSingleNone(db) }

  @Test
  @DisplayName("jsonSingle succeeds when a document is found")
  def jsonSingleOne(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.jsonSingleOne(db) }

  @Test
  @DisplayName("nonQuery makes changes")
  def nonQueryChanges(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.nonQueryChanges(db) }

  @Test
  @DisplayName("nonQuery makes no changes when where clause matches nothing")
  def nonQueryNoChanges(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.nonQueryNoChanges(db) }

  @Test
  @DisplayName("scalar succeeds")
  def scalar(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.scalar(db) }
